unit ConectaDB;

interface

uses  Windows, DB, DBTables, ExtCtrls, Controls, XPMan, Menus, ScktComp, ToolWin,
      Grids, DBGrids, Graphics, Buttons, Classes, Messages, SysUtils, Forms,
      Dialogs, shellapi, DateUtils, ComObj, ShlObj, ActiveX, ADODB,
      IniFiles, StdCtrls, Variants, AdoInt, OleDB;

      function ConectarBancoDados_ADO(oMemo : TMemo; oConexao : TADOConnection) : boolean;

implementation

function EnumSqlServers(AStrings : TStrings) : boolean;
var oDmo,oApp,oServers : OleVariant;
    bResult : boolean;
    i : integer;
begin
  AStrings.Clear;

  try
    oDMO := CreateOleObject('SQLDMO.SQLServer');
    oApp := oDMO.Application;
    oServers := oApp.ListAvailableSQLServers;

    try
      AStrings.BeginUpdate;
      for i := 1 to oServers.Count do
        begin
          Application.ProcessMessages;
          AStrings.Add(oServers.Item(i));
        end;
    finally
      AStrings.EndUpdate;
    end;

    bResult := true;
  except
    bResult := false;
  end;

  oServers := Unassigned;
  oApp := Unassigned;
  oDMO := Unassigned;

  Result := bResult;
end;

function Verificar_Registro_Conexao(): string;
var
 iRegistro : TIniFile;
 sRetorno : string;
begin
 iRegistro := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
 sRetorno := iRegistro.ReadString('Conexao', 'Instancia', '');
 iRegistro.Destroy;

 result := sRetorno;
end;

procedure Gravar_Registro_Conexao(InstanciaSQLServer : string);
var
 iRegistro : TIniFile;
 sRetorno : string;
begin
 iRegistro := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
 iRegistro.WriteString('Conexao', 'Instancia', InstanciaSQLServer);
 iRegistro.Destroy;
end;

function ConectarBancoDados_ADO(oMemo : TMemo; oConexao : TADOConnection) : boolean;
var
  sRetorno, sServidor : string;
begin
  Result := True;
  oMemo.Lines.Clear;
  sRetorno := Verificar_Registro_Conexao();

  try
    if sRetorno = '' then
      begin
        if EnumSqlServers(oMemo.Lines) then
          begin
            if oMemo.Lines.Count = 1 then sServidor := oMemo.Lines.Strings[0];
          end;

        if oMemo.Lines.Count > 1 then
          begin
            {  Implementar ... }
          end;

        Gravar_Registro_Conexao(sServidor);

      end
    else
      sServidor := sRetorno;

    oConexao.ConnectionString:='Provider=SQLNCLI.1;Integrated Security=SSPI;Persist Security Info=False;Initial Catalog=lan_controler;Data Source=' + sServidor;
    oConexao.Open();
    oConexao.Execute('Set Quoted_Identifier Off');

  except
    Result := False;
  end;
end;


end.
