unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DB, ADODB, Buttons, Grids, DBGrids, StdCtrls;

type
  TForm1 = class(TForm)
    SpeedButton1: TSpeedButton;
    ConectorDBAdo: TADOConnection;
    oProcessar: TADOQuery;
    DBGrid1: TDBGrid;
    DataSource1: TDataSource;
    Memo1: TMemo;
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
  function retorna_nome_maquina(sIP : string): string;
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses ConectaDB;

function Aspas_simples(sstring : string) : string;
begin
  result := #39 + sstring + #39;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  ConectarBancoDados_ADO(Memo1, ConectorDBAdo);
end;

function TForm1.retorna_nome_maquina(sIP : string): string;
begin
  result := '';

  if sIP = 'Todos' then
     begin
       result := 'TODOS';
       Exit;
     end;

  with oProcessar do
    begin
      Close;
      SQL.Clear;
      SQL.Add('SELECT NOME_TERMINAL FROM COMPUTERS');
      SQL.Add('WHERE IP = ' + Aspas_simples(sIP));
      Open;
      Result := FieldByName('NOME_TERMINAL').Text;
    end;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
var
  sIP : string;
begin
  sIP := retorna_nome_maquina('192.168.0.11');
  ShowMessage(sIP);
end;

end.
